;--------------------------------------------------------
;AutoIt Version: 3.2.4.9
;
;Script Author: Andrew Calcutt
;Script Date: 07/09/2007
;Script Name: Vistumbler
;Script Function: Set IP address of a specific connection
;--------------------------------------------------------
#include <File.au3>
#include <Array.au3>
#Include <process.au3>
#include <GuiConstants.au3>
#Include <GuiListView.au3>

$tempfile = "C:\Vistumbler_Temp.txt"
Dim $TempFileArray
Dim $SSID, $NetworkType, $Authentication, $Encryption, $BSSID, $Signal, $RadioType, $Channel, $BasicTransferRates, $OtherTransferRates, $Scan, $display
Dim $SSID_Array[1]
Dim $NetworkType_Array[1]
Dim $Authentication_Array[1]
Dim $Encryption_Array[1]
Dim $BSSID_Array[1]
Dim $Signal_Array[1]
Dim $RadioType_Array[1]
Dim $Channel_Array[1]
Dim $BasicTransferRates_Array[1]
Dim $OtherTransferRates_Array[1]
Dim $LastActive_Array[1]
Dim $Active_Array[1]

If @OSVersion <> "WIN_VISTA" Then MsgBox(0, "Warning", "This Program will only run in Vista. It relies on a netsh command that is not avalible in older versions of windows")


#Region ### START Koda GUI section ### Form=c:\users\acalcutt\documents\aform1.kxf
Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode 
$Form1_1 = GUICreate("Vistumbler V1.0 - By Andrew Calcutt", 625, 445, -1, -1, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS))
$ScanButton = GUICtrlCreateButton("Scan", 16, 8, 57, 17, 0)
GUICtrlSetOnEvent($ScanButton, "ScanToggle")
$SaveButton = GUICtrlCreateButton("Save", 80, 8, 57, 17, 0)
GUICtrlSetOnEvent($SaveButton, "SaveList")
GUISetOnEvent($GUI_EVENT_CLOSE, "CLOSEClicked")
GUICtrlCreateLabel("Set loop delay(mS):", 144, 8,  100, 17)
$sleeptime = GUICtrlCreateEdit(500, 244, 8, 57, 17, 0)
GUICtrlCreateLabel("Actual loop delay(mS):", 310, 8,  110, 17)
$timediff = GUICtrlCreateEdit("", 420, 8, 57, 17, 0)
;$Button5 = GUICtrlCreateButton("AButton1", 272, 8, 57, 17, 0)
;$Button6 = GUICtrlCreateButton("AButton1", 336, 8, 57, 17, 0)
$ListView1 = GUICtrlCreateListView("SSID|Network Type|Authentication|Encryption|BSSID|Signal|Radio Type|Channel|Basic Transfer Rates|Other Transfer Rates|Last Active|Active", 8, 40, 609, 401)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

While 1
	$begin = TimerInit()
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit

	EndSwitch
	If $Scan = 1 Then
		
		_RunDOS("netsh wlan show networks mode=bssid > " & $tempfile)
		_FileReadToArray($tempfile, $TempFileArray)
		

		For $loop = 1 To $TempFileArray[0]
			If StringInStr($TempFileArray[$loop], "SSID") Then
				Dim $SSID = '', $NetworkType = '', $Authentication = '', $Encryption = '', $BSSID = '', $Signal = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '' ;Clear Variables
				While StringInStr($TempFileArray[$loop + 1], "SSID") <> 1
					If StringInStr($TempFileArray[$loop], "BSSID") Then
						$temp0 = StringSplit($TempFileArray[$loop], ":")
						$BSSID = $temp0[2] & ':' & $temp0[3] & ':' & $temp0[4] & ':' & $temp0[5] & ':' & $temp0[6] & ':' & $temp0[7]
					ElseIf StringInStr($TempFileArray[$loop], "SSID") Then
						$temp1 = StringSplit($TempFileArray[$loop], ":")
						$SSID = $temp1[2]
					ElseIf StringInStr($TempFileArray[$loop], "Network type") Then
						$temp2 = StringSplit($TempFileArray[$loop], ":")
						$NetworkType = $temp2[2]
					ElseIf StringInStr($TempFileArray[$loop], "Authentication") Then
						$temp3 = StringSplit($TempFileArray[$loop], ":")
						$Authentication = $temp3[2]
					ElseIf StringInStr($TempFileArray[$loop], "Encryption") Then
						$temp4 = StringSplit($TempFileArray[$loop], ":")
						$Encryption = $temp4[2]
					ElseIf StringInStr($TempFileArray[$loop], "Signal") Then
						$temp5 = StringSplit($TempFileArray[$loop], ":")
						$Signal = $temp5[2]
					ElseIf StringInStr($TempFileArray[$loop], "Radio Type") Then
						$temp6 = StringSplit($TempFileArray[$loop], ":")
						$RadioType = $temp6[2]
					ElseIf StringInStr($TempFileArray[$loop], "Channel") Then
						$temp7 = StringSplit($TempFileArray[$loop], ":")
						$Channel = $temp7[2]
					ElseIf StringInStr($TempFileArray[$loop], "Basic Rates") Then
						$temp8 = StringSplit($TempFileArray[$loop], ":")
						$BasicTransferRates = $temp8[2]
					ElseIf StringInStr($TempFileArray[$loop], "Other Rates") Then
						$temp9 = StringSplit($TempFileArray[$loop], ":")
						$OtherTransferRates = $temp9[2]
					EndIf
					If ($loop + 1) >= $TempFileArray[0] Then ExitLoop
					$loop += 1
				WEnd
				$arraysearch = _ArraySearch($BSSID_Array, $BSSID)
				If $arraysearch = -1 Then
					_ArrayAdd($SSID_Array, $SSID)
					_ArrayAdd($NetworkType_Array, $NetworkType)
					_ArrayAdd($Authentication_Array, $Authentication)
					_ArrayAdd($Encryption_Array, $Encryption)
					_ArrayAdd($BSSID_Array, $BSSID)
					_ArrayAdd($Signal_Array, $Signal)
					_ArrayAdd($RadioType_Array, $RadioType)
					_ArrayAdd($Channel_Array, $Channel)
					_ArrayAdd($BasicTransferRates_Array, $BasicTransferRates)
					_ArrayAdd($OtherTransferRates_Array, $OtherTransferRates)
					_ArrayAdd($LastActive_Array, @MDAY & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & ':' & @MIN & ':' & @SEC)
					_ArrayAdd($Active_Array, "Active")
				Else
					;MsgBox(0, $loop, $SSID_Array[$arraysearch])
					$SSID_Array[$arraysearch] = $SSID
					$NetworkType_Array[$arraysearch] = $NetworkType
					$Authentication_Array[$arraysearch] = $Authentication
					$Encryption_Array[$arraysearch] = $Encryption
					$BSSID_Array[$arraysearch] = $BSSID
					$Signal_Array[$arraysearch] = $Signal
					$RadioType_Array[$arraysearch] = $RadioType
					$Channel_Array[$arraysearch] = $Channel
					$BasicTransferRates_Array[$arraysearch] = $BasicTransferRates
					$OtherTransferRates_Array[$arraysearch] = $OtherTransferRates
					$LastActive_Array[$arraysearch] = @MDAY & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & ':' & @MIN & ':' & @SEC
					$Active_Array[$arraysearch] = "Active"
				EndIf
			EndIf
		Next
		$BSSID_Array[0] = (UBound($BSSID_Array) - 1)
		$Active_Array[0] = (UBound($Active_Array) - 1)
		_GUICtrlListViewDeleteAllItems($ListView1)
		For $display = 1 To $BSSID_Array[0]
			GUICtrlCreateListViewItem($SSID_Array[$display] & '|' & $NetworkType_Array[$display] & '|' & $Authentication_Array[$display] & '|' & $Encryption_Array[$display] & '|' & $BSSID_Array[$display] & '|' & $Signal_Array[$display] & '|' & $RadioType_Array[$display] & '|' & $Channel_Array[$display] & '|' & $BasicTransferRates_Array[$display] & '|' & $OtherTransferRates_Array[$display] & '|' & $LastActive_Array[$display] & '|' & $Active_Array[$display], $ListView1)
			$Active_Array[$display] = ''
		Next
	EndIf
	If TimerDiff($begin) <= GUICtrlRead($sleeptime) Then Sleep(GUICtrlRead($sleeptime) - TimerDiff($begin))
	GUICtrlSetData($timediff, TimerDiff($begin))
WEnd
Func ScanToggle()
	If $Scan = 1 Then
		$Scan = 0
		GUICtrlSetData($ScanButton, "Scan")
	Else
		$Scan = 1
		GUICtrlSetData($ScanButton, "Stop")
	EndIf
EndFunc   ;==>_ScanToggle

Func SaveList()
	$file = FileSaveDialog("Output File", @ScriptDir, 'Text (*.txt)')
	For $display = 1 To $BSSID_Array[0]
		FileWriteLine($file, $SSID_Array[$display] & '|' & $NetworkType_Array[$display] & '|' & $Authentication_Array[$display] & '|' & $Encryption_Array[$display] & '|' & $BSSID_Array[$display] & '|' & $Signal_Array[$display] & '|' & $RadioType_Array[$display] & '|' & $Channel_Array[$display] & '|' & $BasicTransferRates_Array[$display] & '|' & $OtherTransferRates_Array[$display] & '|' & $LastActive_Array[$display] & '|' & $Active_Array[$display])
	Next
EndFunc   ;==>_SaveList

Func CLOSEClicked()
	Exit
EndFunc